#include <stdio.h>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main() {
  
  // Get input
  int N;
  scanf("%d\n", &N);
  vector<int> choices (N);
  for(int i=0; i<N; i+=2) {
    scanf("%d", &choices[i]);
  }
  for(int i=1; i<N; i+=2) {
    scanf("%d", &choices[i]);
  }
  
  // Initialize a binary tree:
  // the root is at index 1; left_child(v)=2*v; right_child(v)=2*v+1; parent(v)=v/2; 
  // the leaves represent the players; they appear in positions {inner_size,..., inner_size+N-1};
  // each entry will contain the number of available players in the subtree.
  int inner_size = pow(2, ceil(log2(N)));
  vector<int> tree (2*inner_size, 0);
  for (int v = inner_size; v < inner_size + N; v++) {
    tree[v] = 1;
  }
  for (int v = inner_size - 1; v > 0; v--) {
    tree[v] = tree[2*v] + tree[2*v +1];
  }

  // Go over all selection steps
  vector<int> selected (N);
  for (int i=0; i<N; i++) {
    // Find the leaf corresponding to the selected player
    int subtree_choice = choices[i] - 1;
    int v = 1;
    while (v < inner_size) {
      if (subtree_choice < tree[2*v]) {
        v = 2*v;
      } else {
        subtree_choice -= tree[2*v];
        v = 2*v + 1;
      }
    }
    // Update the tree to remove the selected player
    for (int u=v; u>0; u/=2) {
      tree[u]--;
    }
    // Store the selection
    selected[i] = v - inner_size + 1;
  }

  
  // Print output
  printf("%d", selected[0]);
  for(int i=2; i<N; i+=2) {
    printf(" %d", selected[i]);
  }
  printf("\n");
  printf("%d", selected[1]);
  for(int i=3; i<N; i+=2) {
    printf(" %d", selected[i]);
  }
  printf("\n");
  
  return 0;
}
